# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'ChunkConfig',
    'ClusterConfig',
    'Connection',
    'ConnectionConfig',
    'Disk',
    'DiskConfig',
    'DiskSpec',
    'NodeConfig',
    'PartitionConfig',
    'SSD',
]

@pulumi.output_type
class ChunkConfig(dict):
    def __init__(__self__, *,
                 coding: int,
                 data: int):
        pulumi.set(__self__, "coding", coding)
        pulumi.set(__self__, "data", data)

    @property
    @pulumi.getter
    def coding(self) -> int:
        return pulumi.get(self, "coding")

    @property
    @pulumi.getter
    def data(self) -> int:
        return pulumi.get(self, "data")


@pulumi.output_type
class ClusterConfig(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "deviceClass":
            suggest = "device_class"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ClusterConfig. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ClusterConfig.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ClusterConfig.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: str,
                 chunks: Optional['outputs.ChunkConfig'] = None,
                 device_class: Optional[str] = None,
                 replicas: Optional[int] = None):
        pulumi.set(__self__, "name", name)
        if chunks is not None:
            pulumi.set(__self__, "chunks", chunks)
        if device_class is not None:
            pulumi.set(__self__, "device_class", device_class)
        if replicas is not None:
            pulumi.set(__self__, "replicas", replicas)

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def chunks(self) -> Optional['outputs.ChunkConfig']:
        return pulumi.get(self, "chunks")

    @property
    @pulumi.getter(name="deviceClass")
    def device_class(self) -> Optional[str]:
        return pulumi.get(self, "device_class")

    @property
    @pulumi.getter
    def replicas(self) -> Optional[int]:
        return pulumi.get(self, "replicas")


@pulumi.output_type
class Connection(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "privateKey":
            suggest = "private_key"
        elif key == "privateKeyPass":
            suggest = "private_key_pass"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in Connection. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        Connection.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        Connection.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 host: str,
                 private_key: str,
                 port: Optional[int] = None,
                 private_key_pass: Optional[str] = None,
                 user: Optional[str] = None):
        pulumi.set(__self__, "host", host)
        pulumi.set(__self__, "private_key", private_key)
        if port is not None:
            pulumi.set(__self__, "port", port)
        if private_key_pass is not None:
            pulumi.set(__self__, "private_key_pass", private_key_pass)
        if user is not None:
            pulumi.set(__self__, "user", user)

    @property
    @pulumi.getter
    def host(self) -> str:
        return pulumi.get(self, "host")

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> str:
        return pulumi.get(self, "private_key")

    @property
    @pulumi.getter
    def port(self) -> Optional[int]:
        return pulumi.get(self, "port")

    @property
    @pulumi.getter(name="privateKeyPass")
    def private_key_pass(self) -> Optional[str]:
        return pulumi.get(self, "private_key_pass")

    @property
    @pulumi.getter
    def user(self) -> Optional[str]:
        return pulumi.get(self, "user")


@pulumi.output_type
class ConnectionConfig(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "privateKeyPath":
            suggest = "private_key_path"
        elif key == "privateKeyPass":
            suggest = "private_key_pass"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConnectionConfig. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConnectionConfig.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConnectionConfig.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 host: str,
                 private_key_path: str,
                 port: Optional[int] = None,
                 private_key_pass: Optional[str] = None,
                 user: Optional[str] = None):
        pulumi.set(__self__, "host", host)
        pulumi.set(__self__, "private_key_path", private_key_path)
        if port is not None:
            pulumi.set(__self__, "port", port)
        if private_key_pass is not None:
            pulumi.set(__self__, "private_key_pass", private_key_pass)
        if user is not None:
            pulumi.set(__self__, "user", user)

    @property
    @pulumi.getter
    def host(self) -> str:
        return pulumi.get(self, "host")

    @property
    @pulumi.getter(name="privateKeyPath")
    def private_key_path(self) -> str:
        return pulumi.get(self, "private_key_path")

    @property
    @pulumi.getter
    def port(self) -> Optional[int]:
        return pulumi.get(self, "port")

    @property
    @pulumi.getter(name="privateKeyPass")
    def private_key_pass(self) -> Optional[str]:
        return pulumi.get(self, "private_key_pass")

    @property
    @pulumi.getter
    def user(self) -> Optional[str]:
        return pulumi.get(self, "user")


@pulumi.output_type
class Disk(dict):
    def __init__(__self__, *,
                 id: str):
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> str:
        return pulumi.get(self, "id")


@pulumi.output_type
class DiskConfig(dict):
    def __init__(__self__, *,
                 hdds: Sequence['outputs.Disk'],
                 ssds: Sequence['outputs.SSD']):
        pulumi.set(__self__, "hdds", hdds)
        pulumi.set(__self__, "ssds", ssds)

    @property
    @pulumi.getter
    def hdds(self) -> Sequence['outputs.Disk']:
        return pulumi.get(self, "hdds")

    @property
    @pulumi.getter
    def ssds(self) -> Sequence['outputs.SSD']:
        return pulumi.get(self, "ssds")


@pulumi.output_type
class DiskSpec(dict):
    def __init__(__self__, *,
                 hdds: Sequence['outputs.Disk'],
                 ssds: Sequence['outputs.SSD']):
        pulumi.set(__self__, "hdds", hdds)
        pulumi.set(__self__, "ssds", ssds)

    @property
    @pulumi.getter
    def hdds(self) -> Sequence['outputs.Disk']:
        return pulumi.get(self, "hdds")

    @property
    @pulumi.getter
    def ssds(self) -> Sequence['outputs.SSD']:
        return pulumi.get(self, "ssds")


@pulumi.output_type
class NodeConfig(dict):
    def __init__(__self__, *,
                 disks: 'outputs.DiskConfig',
                 host: str,
                 connection: Optional['outputs.ConnectionConfig'] = None):
        pulumi.set(__self__, "disks", disks)
        pulumi.set(__self__, "host", host)
        if connection is not None:
            pulumi.set(__self__, "connection", connection)

    @property
    @pulumi.getter
    def disks(self) -> 'outputs.DiskConfig':
        return pulumi.get(self, "disks")

    @property
    @pulumi.getter
    def host(self) -> str:
        return pulumi.get(self, "host")

    @property
    @pulumi.getter
    def connection(self) -> Optional['outputs.ConnectionConfig']:
        return pulumi.get(self, "connection")


@pulumi.output_type
class PartitionConfig(dict):
    def __init__(__self__, *,
                 db: str,
                 osd: str,
                 wal: str):
        pulumi.set(__self__, "db", db)
        pulumi.set(__self__, "osd", osd)
        pulumi.set(__self__, "wal", wal)

    @property
    @pulumi.getter
    def db(self) -> str:
        return pulumi.get(self, "db")

    @property
    @pulumi.getter
    def osd(self) -> str:
        return pulumi.get(self, "osd")

    @property
    @pulumi.getter
    def wal(self) -> str:
        return pulumi.get(self, "wal")


@pulumi.output_type
class SSD(dict):
    def __init__(__self__, *,
                 id: str,
                 partitions: 'outputs.PartitionConfig'):
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "partitions", partitions)

    @property
    @pulumi.getter
    def id(self) -> str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def partitions(self) -> 'outputs.PartitionConfig':
        return pulumi.get(self, "partitions")


